﻿using Ini.Net;
using Microsoft.Win32;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace GcDevicePc
{
    public partial class SysConfig : Form
    {
        public SysConfig()
        {
            InitializeComponent();
        }

        private void CheckBox1_CheckedChanged(object sender, EventArgs e)
        {

        }

        private void Thirdparty_CheckedChanged(object sender, EventArgs e)
        {

        }

        private void Foreign_CheckedChanged(object sender, EventArgs e)
        {

        }

        private void ListBox1_DrawItem(object sender, DrawItemEventArgs e)
        {
            e.Graphics.FillRectangle(new SolidBrush(e.BackColor), e.Bounds);
            if (e.Index >= 0)
            {
                StringFormat sStringFormat = new StringFormat();
                sStringFormat.LineAlignment = StringAlignment.Center;
                e.Graphics.DrawString(((ListBox)sender).Items[e.Index].ToString(), e.Font, new SolidBrush(e.ForeColor), e.Bounds, sStringFormat);
            }
            e.DrawFocusRectangle();
        }

        private void ListBox1_MeasureItem(object sender, MeasureItemEventArgs e)
        {
            e.ItemHeight = e.ItemHeight + 12;
        }

        private void ListBox1_SelectedIndexChanged(object sender, EventArgs e)
        {
            panel1.Visible = false;
            panel2.Visible = false;
            panel3.Visible = false;
            if (this.listBox1.SelectedIndex == 0)
            {
                panel1.Visible = true;
            }
            else if (this.listBox1.SelectedIndex == 1)
            {
                panel2.Visible = true;
            }
            else if (this.listBox1.SelectedIndex == 2)
            {
                panel3.Visible = true;
            }
        }

        private void SysConfig_Load(object sender, EventArgs e)
        {
            string file = Path.Combine(Path.GetDirectoryName(System.Windows.Forms.Application.StartupPath), "GC_Config\\GC_Set\\启动参数\\startup.ini");
            if (File.Exists(file))
            {
                IniFile ini = new IniFile(file);

                string value = ini.ReadString("StartUp", "自启动");
                string opensys = ini.ReadString("StartUp", "打开系统");
                string runtype = ini.ReadString("StartUp", "运行类型");
                string info_log = ini.ReadString("Logs", "InfoLog");
                string err_log = ini.ReadString("Logs", "ErrLog");
                string hmi_log = ini.ReadString("Logs", "HmiLog");

                int Version = ini.ReadInteger("Version", "VersionType");
                string uname = ini.ReadString("User", "Name");
                string upwd = ini.ReadString("User", "Password");


                int dsf = ini.ReadInteger("SendData", "Thirdparty");
                int dw = ini.ReadInteger("SendData", "Foreign");

                if (Convert.ToInt32(value) == 1)
                {
                    this.appstartup.Checked = true;
                }
                else
                {
                    this.appstartup.Checked = false;
                }

                if (Convert.ToInt32(opensys) == 1)
                {
                    if (Convert.ToInt32(runtype) == 2)
                    {
                        this.runbat.Checked = true;
                    }
                }

                if (Convert.ToInt32(info_log) == 1)
                {
                    this.permin.Checked = false;
                }
                else
                {
                    this.permin.Checked = true;
                }

                if (Version == 1)
                {
                    this.checkBox1.Checked = true;
                }
                else
                {
                    this.checkBox1.Checked = false;
                }

                textBox1.Text = uname;
                textBox2.Text = upwd;
                textBox3.Text = upwd;

                switch (dsf)
                {
                    case 0:
                        radioButton2.Checked = true;
                        break;
                    case 1:
                        radioButton1.Checked = true;

                        break;
                    case 2:
                        radioButton3.Checked = true;

                        break;
                    default:
                        radioButton1.Checked = false;
                        radioButton2.Checked = false;
                        radioButton3.Checked = false;
                        break;
                }

                switch (dw)
                {
                    case 0:
                        radioButton5.Checked = true;
                        break;
                    case 1:
                        radioButton6.Checked = true;
                        break;
                    default:
                        radioButton5.Checked = false;
                        radioButton5.Checked = false;
                        break;
                }
            }
            else
            {

            }
            listBox1.SelectedIndex = 0;
        }

        private void Button1_Click(object sender, EventArgs e)
        {
            string file = Path.Combine(Path.GetDirectoryName(System.Windows.Forms.Application.StartupPath), "GC_Config\\GC_Set\\启动参数\\startup.ini");
            if (File.Exists(file))
            {
                IniFile ini = new IniFile(file);

                if (appstartup.Checked)
                {
                    ini.WriteString("StartUp", "自启动", "1");
                    string path = Application.ExecutablePath;
                    RegistryKey rk = Registry.LocalMachine;
                    RegistryKey rk2 = rk.CreateSubKey(@"Software\Microsoft\Windows\CurrentVersion\Run");
                    rk2.SetValue("JcShutdown", path);
                    rk2.Close();
                    rk.Close();

                }
                else
                {
                    ini.WriteString("StartUp", "自启动", "0");
                    string path = Application.ExecutablePath;
                    RegistryKey rk = Registry.LocalMachine;
                    RegistryKey rk2 = rk.CreateSubKey(@"Software\Microsoft\Windows\CurrentVersion\Run");
                    rk2.DeleteValue("JcShutdown", false);
                    rk2.Close();
                    rk.Close();
                }

                if (runbat.Checked)
                {
                    ini.WriteString("StartUp", "打开系统", "1");
                    ini.WriteString("StartUp", "运行类型", "2");
                }
                else if(runsingle.Checked)
                {
                    ini.WriteString("StartUp", "打开系统", "1");
                    ini.WriteString("StartUp", "运行类型", "1");
                }
                else
                {
                    ini.WriteString("StartUp", "打开系统", "0");
                    ini.WriteString("StartUp", "运行类型", "0");
                }

                if (this.permin.Checked == true)
                {
                    ini.WriteString("Logs", "HmiLog", "0");
                    globaldata.m_pcbuffer.gcpcinfo.pcworkinfo.hmi_log = false;
                }
                else
                {
                    ini.WriteString("Logs", "HmiLog", "1");
                    globaldata.m_pcbuffer.gcpcinfo.pcworkinfo.hmi_log = true;
                }

                if (checkBox1.Checked)
                {
                    ini.WriteString("Version", "VersionType", "1");
                }
                else
                {
                    ini.WriteString("Version", "VersionType", "0");
                }


                if (radioButton1.Checked)
                {
                    ini.WriteString("SendData", "Thirdparty", "1");//zb
                }
                else if (radioButton2.Checked)
                {
                    ini.WriteString("SendData", "Thirdparty", "0");//hl
                }
                else if (radioButton3.Checked)
                {
                    ini.WriteString("SendData", "Thirdparty", "2");//sp
                }
                else
                {
                    ini.WriteString("SendData", "Thirdparty", "3");//无
                }


                if (radioButton5.Checked)
                {
                    ini.WriteString("SendData", "Foreign", "0");//默认
                }
                else if (radioButton6.Checked)
                {
                    ini.WriteString("SendData", "Foreign", "1");//环空
                }
                else
                {
                    ini.WriteString("SendData", "Foreign", "2");//无
                }

                if (label4.Visible || label5.Visible|| label6.Visible)
                {
                    MessageBox.Show("请确保安全性");
                    return;
                }
                else
                {
                    ini.WriteString("User", "Name", textBox1.Text);
                    ini.WriteString("User", "Password", textBox3.Text);
                }

                this.Close();
            }
            else
            {
                MessageBox.Show("配置保存失败");
            }
        }

        private void TextBox1_TextChanged(object sender, EventArgs e)
        {
            if (string.IsNullOrEmpty(textBox1.Text))
            {
                label4.Visible = true;
                label4.Text = "不能为空";
            }
            else
            {
                label4.Visible = false;
                label4.Text = "";
            }
        }

        private void TextBox2_TextChanged(object sender, EventArgs e)
        {
            if (string.IsNullOrEmpty(textBox2.Text))
            {
                label5.Visible = true;
                label5.Text = "不能为空";
            }
            else
            {
                label5.Visible = false;
                label5.Text = "";
            }
        }

        private void TextBox3_TextChanged(object sender, EventArgs e)
        {
            if (string.IsNullOrEmpty(textBox3.Text))
            {
                label6.Visible = true;
                label6.Text = "不能为空";
            }
            else if (!textBox3.Text.Equals(textBox2.Text))
            {
                label6.Visible = true;
                label6.Text = "密码不一致";
            }
            else
            {
                label6.Visible = false;
                label6.Text = "";
            }
        }

        private void Button2_Click(object sender, EventArgs e)
        {
            this.Close();
        }
    }
}
